一、小括号,圆括号()

1、单小括号 ()

① 命令组。括号中的命令将会新开一个子shell顺序执行,所以括号中的变量不能够被脚本余下的部分使用。括号中多个命令之间用分号隔开,最后一个命令可以没有分号,各命令和括号之间不必有空格。

(echo 'abc';exit) #shell并不会退出,因为运行在子shell

② 命令替换。等同于cmd,shell扫描一遍命令行,发现了$(cmd)结构,便将$(cmd)中的cmd执行一次,得到其标准输出,再将此输出放到原来命令。有些shell不支持,如tcsh。

a=' abc'
a=$(echo 'a')

③ 用于初始化数组。如:array=(a b c d)

2、双小括号 (( ))

① 整数扩展。这种扩展计算是整数型的计算,不支持浮点型。((exp))结构扩展并计算一个算术表达式的值,如果表达式的结果为0,那么返回的退出状态码为1,或者 是"假",而一个非零值的表达式所返回的退出状态码将为0,或者是"true"。若是逻辑判断,表达式exp为真则为1,假则为0。

② 只要括号中的运算符、表达式符合C语言运算规则,都可用在$((exp))中,甚至是三目运算符。作不同进位(如二进制、八进制、十六进制)运算时,输出结果全都自动转化成了十进制。如:echo $((16#5f)) 结果为95 (16进位转十进制)

③ 单纯用 (( )) 也可重定义变量值,比如 a=5; ((a++)) 可将 $a 重定义为6

④ 常用于算术运算比较,双括号中的变量可以不使用$符号前缀。括号内支持多个表达式用逗号分开。 只要括号中的表达式符合C语言运算规则,比如可以直接使用for((i=0;i<5;i++)), 如果不使用双括号, 则为for i in seq 0 4或者for i in {0..4}。再如可以直接使用if (($i<5)), 如果不使用双括号, 则为if [ $i -lt 5 ]。

a=1
b=2
c=3

((a=a+1))

echo $a #输出2

a=$((a+1,b++,c++))

echo $a,$b,$c #输出3,3,4

if ((1-1));then echo a;fi #无输出

if ((2-1));then echo a;fi #输出a

二、中括号,方括号[ ]

1、单中括号 [ ]

① bash 的内部命令,[和test是等同的。如果我们不用绝对路径指明,通常我们用的都是bash自带的命令。if/test结构中的左中括号是调用test的命令标识,右中括号是关闭条件判断的。这个命令把它的参数作为比较表达式或者作为文件测试,并且根据比较的结果来返回一个退出状态码。if/test结构中并不是必须右中括号,但是新版的Bash中要求必须这样。

② Test和[]中可用的比较运算符只有==和!=,两者都是用于字符串比较的,不可用于整数比较,整数比较只能使用-eq,-gt这种形式。无论是字符串比较还是整数比较都不支持大于号小于号。如果实在想用,对于字符串比较可以使用转义形式,如果比较"ab"和"bc":[ ab < bc ],结果为真,也就是返回状态为0。[ ]中的逻辑与和逻辑或使用-a 和-o 表示。

③ 字符范围。用作正则表达式的一部分,描述一个匹配的字符范围。作为test用途的中括号内不能使用正则。

④ 在一个array 结构的上下文中,中括号用来引用数组中每个元素的编号。

2、双中括号[[ ]]

① [[是 bash 程序语言的关键字。并不是一个命令,[[ ]] 结构比[ ]结构更加通用。在[[和]]之间所有的字符都不会发生文件名扩展或者单词分割,但是会发生参数扩展和命令替换。

② 支持字符串的模式匹配,使用=~操作符时甚至支持shell的正则表达式。字符串比较时可以把右边的作为一个模式,而不仅仅是一个字符串,比如[[ hello == hell? ]],结果为真。[[ ]] 中匹配字符串或通配符,不需要引号。
③ 使用[[ ... ]]条件判断结构,而不是[ ... ],能够防止脚本中的许多逻辑错误。比如,&&、||、< 和 > 操作符能够正常存在于[[ ]]条件判断结构中,但是如果出现在[ ]结构中的话,会报错。比如可以直接使用if [[ $a != 1 && $a != 2 ]], 如果不适用双括号, 则为if [ $a -ne 1] && [ $a != 2 ]或者if [ $a -ne 1 -a $a != 2 ]。

④ bash把双中括号中的表达式看作一个单独的元素,并返回一个退出状态码。

if ($i < 5)
if [ $i -lt 5 ]
if [ $a -ne 1 -a $a != 2 ]
if [ $a -ne 1] && [ $a != 2 ]
if [[ $a != 1 && $a != 2 ]]

for i in $(seq 0 4);do echo $i;done
for i in `seq 0 4`;do echo $i;done
for ((i=0;i < 5;i++));do echo $i;done
for i in {0..4};do echo $i;done

三、大括号、花括号 {}

1、常规用法

① 大括号拓展。(通配(globbing))将对大括号中的文件名做扩展。在大括号中,不允许有空白,除非这个空白被引用或转义。第一种:对大括号中的以逗号分割的文件列表进行拓展。如 touch {a,b}.txt 结果为a.txt b.txt。第二种:对大括号中以点点(..)分割的顺序文件列表起拓展作用,如:touch {a..d}.txt 结果为a.txt b.txt c.txt d.txt

ls {ex1,ex2}.sh #输出ex1.sh ex2.sh

ls {ex{1..3},ex4}.sh #输出ex1.sh ex2.sh ex3.sh ex4.sh

ls {ex[1-3],ex4}.sh #输出ex1.sh ex2.sh ex3.sh ex4.sh

② 代码块,又被称为内部组,这个结构事实上创建了一个匿名函数 。与小括号中的命令不同,大括号内的命令不会新开一个子shell运行,即脚本余下部分仍可使用括号内变量。括号内的命令间用分号隔开,最后一个也必须有分号。{}的第一个命令和左括号之间必须要有一个空格。

2、几种特殊的替换结构
${var:-string}
${var:+string}
${var:=string}
${var:?string}

① ${var:-string}和${var:=string}:若变量var为空,则用在命令行中用string来替换${var:-string},否则变量var不为空时,则用变量var的值来替换${var:-string};对于${var:=string}的替换规则和${var:-string}是一样的,所不同之处是${var:=string}若var为空时,用string替换${var:=string}的同时,把string赋给变量var: ${var:=string}很常用的一种用法是,判断某个变量是否赋值,没有的话则给它赋上一个默认值。

② ${var:+string}的替换规则和上面的相反,即只有当var不是空的时候才替换成string,若var为空时则不替换或者说是替换成变量 var的值,即空值。(因为变量var此时为空,所以这两种说法是等价的)

③ ${var:?string}替换规则为:若变量var不为空,则用变量var的值来替换${var:?string};若变量var为空,则把string输出到标准错误中,并从脚本中退出。我们可利用此特性来检查是否设置了变量的值。

补充扩展:在上面这五种替换结构中string不一定是常值的,可用另外一个变量的值或是一种命令的输出。

3、四种模式匹配替换结构

模式匹配记忆方法:

# 是去掉左边(在键盘上#在$之左边)
% 是去掉右边(在键盘上%在$之右边)
#和%中的单一符号是最小匹配,两个相同符号是最大匹配。
${var%pattern}
${var%%pattern}
${var#pattern}
${var##pattern}

第一种模式:${variable%pattern},这种模式时,shell在variable中查找,看它是否一给的模式pattern结尾,如果是,就从命令行把variable中的内容去掉右边最短的匹配模式

第二种模式: ${variable%%pattern},这种模式时,shell在variable中查找,看它是否一给的模式pattern结尾,如果是,就从命令行把variable中的内容去掉右边最长的匹配模式

第三种模式:${variable#pattern} 这种模式时,shell在variable中查找,看它是否一给的模式pattern开始,如果是,就从命令行把variable中的内容去掉左边最短的匹配模式

第四种模式: ${variable##pattern} 这种模式时,shell在variable中查找,看它是否一给的模式pattern结尾,如果是,就从命令行把variable中的内容去掉右边最长的匹配模式

这四种模式中都不会改变variable的值,其中,只有在pattern中使用了匹配符号时,%和%%,#和##才有区别。结构中的pattern支持通配符,表示零个或多个任意字符,?表示仅与一个任意字符匹配,[...]表示匹配中括号里面的字符,[!...]表示不匹配中括号里面的字符。

var=testcase

echo $var #输出testcase

echo ${var%s*e} #输出testca

echo $var #输出testcase

echo ${var%%s*e} #输出te

echo ${var#?e} #输出stcase

echo ${var##?e} #输出stcase

echo ${var##*e} #输出空行

echo ${var##*s} #输出e

echo ${var##test} #输出case
4、字符串提取和替换
${var:num}
${var:num1:num2}
${var/pattern/pattern}
${var//pattern/pattern}

第一种模式:${var:num},这种模式时,shell在var中提取第num个字符到末尾的所有字符。若num为正数,从左边0处开始;若num为负数,从右边开始提取字串,但必须使用在冒号后面加空格或一个数字或整个num加上括号,如${var: -2}、${var:1-3}或${var:(-2)}。

第二种模式:${var:num1:num2},num1是位置,num2是长度。表示从$var字符串的第$num1个位置开始提取长度为$num2的子串。不能为负数。

第三种模式:${var/pattern/pattern}表示将var字符串的第一个匹配的pattern替换为另一个pattern。。

第四种模式:${var//pattern/pattern}表示将var字符串中的所有能匹配的pattern替换为另一个pattern。

var=/home/centos

echo $var #输出/home/centos

echo ${var:5} #输出/centos

echo ${var: -6} #输出centos

echo ${var:(-6)} #输出centos

echo ${var:1:4} #输出home

echo ${var/o/h} #输出/hhme/centos

echo ${var//o/h} #输出/hhme/cenths

四、符号$后的括号

(1)${a} 变量a的值, 在不引起歧义的情况下可以省略大括号。

(2)$(cmd) 命令替换,和cmd效果相同,结果为shell命令cmd的输,过某些Shell版本不支持$()形式的命令替换, 如tcsh。

(3)$((expression)) 和exprexpression效果相同, 计算数学表达式exp的数值, 其中exp只要符合C语言的运算规则即可, 甚至三目运算符和逻辑表达式都可以计算。

五、使用

1、多条命令执行

(1)单小括号,(cmd1;cmd2;cmd3) 新开一个子shell顺序执行命令cmd1,cmd2,cmd3, 各命令之间用分号隔开, 最后一个命令后可以没有分号。

(2)单大括号,{ cmd1;cmd2;cmd3;} 在当前shell顺序执行命令cmd1,cmd2,cmd3, 各命令之间用分号隔开, 最后一个命令后必须有分号, 第一条命令和左括号之间必须用空格隔开。
对{}和()而言, 括号中的重定向符只影响该条命令, 而括号外的重定向符影响到括号中的所有命令。

在shell编程中,我们经常都要进行算数允许,那么熟悉以下几种常见的算数运算方法是非常有必要的。

假设有两个变量A和B:

A=1
B=2

1、let 大法

let C=$A+$B
echo $C
3

2、$[] 大法

C=$[$A+$B]
echo $C
3

3、$(()) 大法

C=$(($A+$B))
echo $C
3

4、expr 大法

C=`expr $A + $B`
echo $C
3

getopts场景一:

脚本接收选项-a、-b,如果是-a,安装a服务,如果是b,安装b服务。

#!/bin/bash
#
# getopts不支持长选项

while getopts "ab" arg
do
    case $arg in
        a)
            echo "install a"
            ;;
        b)
            echo "install b"
            ;;
        ?)
            echo "Unkonw argument"
            exit 1
            ;;
    esac
done

getopts场景二:

-b选项需要指定一个参数

#!/bin/bash
#
#

while getopts "ab:" arg
do
    case $arg in
        a)
            echo "a's arg is $OPTARG"
            ;;
        b)
            echo "b's arg is $OPTARG"
            ;;
        ?)
            echo "Unknow argument"
            exit 1
            ;;
    esac
done

getopt场景一:

脚本接收短选项-a、-b 或长选项--servera、--serverb

#!/bin/bash
#
# getopt支持长选项
#-o表示短选项,两个冒号表示该选项有一个可选参数,可选参数必须紧贴选项
#如-carg 而不能是-c arg
#--long表示长选项
#"$@"在上面解释过
# -n:出错时的信息
# -- :举一个例子比较好理解:
#我们要创建一个名字为 "-f"的目录你会怎么办?
# mkdir -f #不成功,因为-f会被mkdir当作选项来解析,这时就可以使用
# mkdir -- -f 这样-f就不会被作为选项

TEMP=`getopt -o ab --long servera,serverb -n "$0" -- "$@"`

[ $? -eq 0 ] || { exit 1; }

# set 会重新排列参数的顺序,也就是改变$1,$2...$n的值,这些值在getopt中重新排列过了
eval set -- "$TEMP"

while true; do
    case "$1" in
        -a|--servera)
            echo "install servera"
            shift
            ;;
        -b|--serverb)
            echo "install serverb"
            shift
            ;;
        --)
            shift
            break
            ;;
        *)
            echo "Error"
            exit 1
            ;;
    esac
done

getopt场景二:

#!/bin/bash
#
#-b选项可以有一个可选参数,可选参数必须紧贴选项
TEMP=`getopt -o ab:: --long servera,serverb:: -n "$0" -- "$@"`

[ $? -eq 0 ] || { exit 1; }
echo "$TEMP"
eval set -- "$TEMP"
echo "$TEMP"

while true; do
    case "$1" in
        -a|--servera)
            echo "install servera"
            shift
            ;;
        -b|--serverb)
            case "$2" in
                "")
                    echo "Option b, no argument"
                    shift 2
                    ;;
                *)
                    echo "Option c, argument is $2"
                    shift 2
                    ;;
            esac
            ;;
        --)
            shift
            break
        *)
            echo "Error"
            exit 1
    esac
done